import * as React from 'react';
import { DraggableEvent, DraggableData } from 'react-draggable';
interface Props {
    children: React.ReactElement;
    defaultPosition: {
        x: number;
        y: number;
    };
    activeClassName?: string;
    onStart?: Function;
    onDrag?: Function;
    onStop?: Function;
}
interface State {
    x: number;
    y: number;
}
export declare class DraggableChild extends React.Component<Props, State> {
    static defaultProps: {
        defaultPosition: {
            x: number;
            y: number;
        };
        onStart: () => void;
        onDrag: () => void;
        onStop: () => void;
    };
    lastX: number;
    lastY: number;
    constructor(props: Props);
    handleStart: (ev: DraggableEvent, b: DraggableData) => void;
    handleDrag: (ev: DraggableEvent, b: DraggableData) => void;
    handleStop: (ev: DraggableEvent, b: DraggableData) => void;
    render(): JSX.Element;
}
export {};
