import * as React from 'react';
interface Props {
    tag: keyof JSX.IntrinsicElements;
    style: React.CSSProperties;
    lineStyle: React.CSSProperties;
    directions: Array<Direction>;
    threshold: number;
    className: string;
    activeClassName: string;
    limit: boolean;
}
interface State {
    vLines: Array<AlignToken>;
    hLines: Array<AlignToken>;
    indices: Array<Number>;
}
declare type AlignToken = {
    $: Element;
    i: number;
    length: number;
    origin: number;
    value: number;
};
declare type DraggableElement = {
    $: Element;
    i: number;
    x: number;
    y: number;
    w: number;
    h: number;
    l: number;
    r: number;
    t: number;
    b: number;
    lr: number;
    tb: number;
};
declare type Grid = {
    x: number;
    y: number;
};
declare type GridKey = keyof Grid;
declare type DirectionX = 'll' | 'rr' | 'lr';
declare type DirectionY = 'tt' | 'bb' | 'tb';
declare type Direction = DirectionY | DirectionX;
export declare class DraggableContainer extends React.Component<Props, State> {
    $: HTMLElement;
    $children: Array<DraggableElement>;
    static defaultProps: {
        tag: string;
        style: {};
        directions: string[];
        threshold: number;
        className: string;
        activeClassName: string;
        limit: boolean;
        lineStyle: {};
    };
    state: State;
    initialize: () => void;
    reset: () => void;
    calc: (index: number) => (x: number, y: number) => {
        x: number;
        y: number;
    };
    /**
    * @param {Object} values xy坐标
    * @param {Object} target 拖拽目标
    * @param {Array} compares 对照组
    */
    calcAndDrawLines(values: Grid, target: DraggableElement, compares: Array<DraggableElement>): {
        x: number;
        y: number;
    };
    calcLineValues(values: Grid, target: DraggableElement, compare: DraggableElement, key: GridKey): {
        length: number;
        origin: number;
    };
    calcPosValues(values: Grid, target: DraggableElement, compares: Array<DraggableElement>, key: GridKey): {
        v: number;
        dist: number;
        lines: AlignToken[];
        indices: number[];
    };
    calcPosValuesSingle(values: Grid, dire: Direction, target: DraggableElement, compare: DraggableElement, key: GridKey): {
        near: boolean;
        dist: number;
        value: number;
        length: number;
        origin: number;
    };
    checkDragOut({ x, y }: {
        x: number;
        y: number;
    }, target: DraggableElement): {
        limitX: number;
        limitY: number;
    };
    _renderGuideLine(): JSX.Element;
    _renderChildren(): React.ReactElement<any, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)>) | (new (props: any) => React.Component<any, any, any>)>[];
    render(): JSX.Element;
}
export {};
